--- /homez.786/ridinteadu/_serious_analysis/van_21.0.0/dolibarr-21.0.0/htdocs/stripe/admin/stripe.php	2025-03-03 15:58:17.000000000 +0000
+++ /homez.786/ridinteadu/seriousbeta/dolibarr/htdocs/stripe/admin/stripe.php	2025-05-06 13:40:12.082202000 +0000
@@ -28,11 +28,11 @@
 
 // Load Dolibarr environment
 require '../../main.inc.php';
-require_once DOL_DOCUMENT_ROOT.'/stripe/lib/stripe.lib.php';
-require_once DOL_DOCUMENT_ROOT.'/core/lib/admin.lib.php';
-require_once DOL_DOCUMENT_ROOT.'/core/class/doleditor.class.php';
-require_once DOL_DOCUMENT_ROOT.'/product/class/html.formproduct.class.php';
-require_once DOL_DOCUMENT_ROOT.'/stripe/class/stripe.class.php';
+require_once DOL_DOCUMENT_ROOT . '/stripe/lib/stripe.lib.php';
+require_once DOL_DOCUMENT_ROOT . '/core/lib/admin.lib.php';
+require_once DOL_DOCUMENT_ROOT . '/core/class/doleditor.class.php';
+require_once DOL_DOCUMENT_ROOT . '/product/class/html.formproduct.class.php';
+require_once DOL_DOCUMENT_ROOT . '/stripe/class/stripe.class.php';
 
 $servicename = 'Stripe';
 
@@ -63,9 +63,19 @@
  */
 $error = 0;
 
+$stripeAccounts = array(
+	'ridin' => 'Ridin’Family',
+	'festi' => 'Festibike',
+);
+
+
+
 if ($action == 'setvalue' && $user->admin) {
+
+
 	$db->begin();
 
+
 	if (empty($conf->stripeconnect->enabled)) {
 		$result = dolibarr_set_const($db, "STRIPE_TEST_PUBLISHABLE_KEY", GETPOST('STRIPE_TEST_PUBLISHABLE_KEY', 'alpha'), 'chaine', 0, '', $conf->entity);
 		if (!($result > 0)) {
@@ -100,6 +110,24 @@
 			$error++;
 		}
 	}
+
+
+	//MODIF JOSE
+	$result = dolibarr_set_const($db, "STRIPE_AUTO_ADD_FEES_TO_BANK", GETPOST('STRIPE_AUTO_ADD_FEES_TO_BANK', 'int'), 'yesno', 0, '', $conf->entity);
+	if (!($result > 0)) $error++;
+
+	$date_start = dol_mktime(0, 0, 0, GETPOST('date_startmonth', 'int'), GETPOST('date_startday', 'int'), GETPOST('date_startyear', 'int'));
+	$date_end = dol_mktime(23, 59, 59, GETPOST('date_endmonth', 'int'), GETPOST('date_endday', 'int'), GETPOST('date_endyear', 'int'));
+
+	$result = dolibarr_set_const($db, "STRIPE_FEES_DATE_START", $date_start, 'chaine', 0, '', $conf->entity);
+	if (!($result > 0)) $error++;
+
+	$result = dolibarr_set_const($db, "STRIPE_FEES_DATE_END", $date_end, 'chaine', 0, '', $conf->entity);
+	if (!($result > 0)) $error++;
+
+	//END MODIF 
+
+
 	$result = dolibarr_set_const($db, "ONLINE_PAYMENT_CREDITOR", GETPOST('ONLINE_PAYMENT_CREDITOR', 'alpha'), 'chaine', 0, '', $conf->entity);
 	if (!($result > 0)) {
 		$error++;
@@ -168,6 +196,192 @@
 	}
 }
 
+
+if ($action == 'manual_reconcile_stripe_payments' && $user->admin) {
+
+	require_once DOL_DOCUMENT_ROOT . '/compta/facture/class/facture.class.php';
+	require_once DOL_DOCUMENT_ROOT . '/compta/paiement/class/paiement.class.php';
+	require_once DOL_DOCUMENT_ROOT . '/compta/bank/class/account.class.php';
+
+	$langs->load("bills");
+	$stripe = new Stripe($db);
+	$added = 0;
+	$options = [];
+
+	$service = (getDolGlobalString('STRIPE_LIVE') && !GETPOST('forcesandbox')) ? 'StripeLive' : 'StripeTest';
+	$stripeacc = $stripe->getStripeAccount($service);
+	if ($stripeacc) $options['stripe_account'] = $stripeacc;
+
+	try {
+		$txn_all = \Stripe\Charge::all(['limit' => 100], $options);
+		$date_start2 = dol_mktime(0, 0, 0, GETPOST('date_start2month', 'int'), GETPOST('date_start2day', 'int'), GETPOST('date_start2year', 'int'));
+		$date_end2 = dol_mktime(23, 59, 59, GETPOST('date_end2month', 'int'), GETPOST('date_end2day', 'int'), GETPOST('date_end2year', 'int'));
+
+
+		foreach ($txn_all->data as $txn) {
+
+
+			if (
+				(empty($date_start2) || $txn->created >= $date_start2) &&
+				(empty($date_end2) || $txn->created <= $date_end2)
+			) {
+
+				$ext_payment_id = $txn->payment_intent;
+
+
+				//Duplicate?
+				$sql = "SELECT rowid FROM " . MAIN_DB_PREFIX . "paiement WHERE ext_payment_id = '" . $db->escape($ext_payment_id) . "'";
+				$resql = $db->query($sql);
+				if ($resql && $db->num_rows($resql) > 0) continue;
+
+				$object_id = 0;
+
+
+
+				if (!empty($txn->metadata->dol_id)) {
+
+					$object_id = $txn->metadata->dol_id;
+
+
+
+					if ($txn->metadata->dol_type == "invoice" || $txn->metadata->dol_type == "facture") {
+						$object = new Facture($db);
+						if ($object->fetch($object_id) <= 0) continue;
+					} elseif ($txn->metadata->dol_type == "order" || $txn->metadata->dol_type == "commande") {
+						$object = new Commande($db);
+						if ($object->fetch($object_id) <= 0) continue;
+					}
+				}
+
+
+
+				if (!$object_id && !empty($txn->metadata->order_id)) {
+					require_once DOL_DOCUMENT_ROOT . '/core/lib/admin.lib.php';
+					$refClient = '#' . $txn->metadata->order_id;
+					$object_id = trouverIdFactureParRefClient($refClient);
+				}
+
+				// $thirdparty_id = 0;
+				// if (!empty($txn->metadata->customer_email)) {
+				// 	$thirdparty_id = trouverIdTiersParEmail($txn->metadata->customer_email);
+				// }
+
+
+				if (!$object_id) {
+					continue;
+				}
+				$paiement = new Paiement($db);
+				$paiement->datepaye = dol_now();
+				$paiement->amounts = [$object->id => $txn->amount / 100];
+				$paiement->paiementid = getDolGlobalInt('STRIPE_PAYMENT_MODE_FOR_PAYMENTS');
+				if (empty($paiement->paiementid)) {
+					$paiement->paiementid = dol_getIdFromCode($db, 'CB', 'c_paiement', 'code', 'id', 1);
+				}
+				$paiement->ext_payment_id = $ext_payment_id;
+				$paiement->ext_payment_site = 'Stripe';
+				$paiement->note_public = 'Paiement Stripe réconcilié manuellement';
+				$paiement->num_payment = $ext_payment_id;
+
+				$db->begin();
+				if ($paiement->create($user) > 0) {
+					$bankaccountid = getDolGlobalInt('STRIPE_BANK_ACCOUNT_FOR_PAYMENTS');
+					$label = '(CustomerInvoicePayment)';
+					if ($bankaccountid > 0) {
+						$res = $paiement->addPaymentToBank($user, 'payment', $label, $bankaccountid, '', '');
+						if ($res > 0) {
+							$db->commit();
+							$added++;
+
+							setEventMessage("Paiement Stripe réconcilié pour la facture ID " . $object->id . " (Montant: " . price($txn->amount / 100, 0, '', 1, -1, -1, $txn->currency) . ")", 'mesgs');
+
+							dol_syslog("STRIPE RECONCILIATION: Paiement créé pour facture ID " . $object->id . ", ext_payment_id=" . $ext_payment_id . ", montant=" . ($txn->amount / 100) . " " . strtoupper($txn->currency), LOG_INFO);
+						} else {
+							dol_syslog("STRIPE RECONCILIATION ERROR: Échec de addPaymentToBank pour facture ID " . $object->id, LOG_ERR);
+							$db->rollback();
+						}
+					} else {
+						dol_syslog("STRIPE RECONCILIATION ERROR: Aucun compte bancaire Stripe défini", LOG_WARNING);
+						setEventMessage("Aucun compte bancaire Stripe défini", 'warnings');
+						$db->rollback();
+					}
+				} else {
+					dol_syslog("STRIPE RECONCILIATION ERROR: Échec de création du paiement pour la facture ID " . $object->id . ". Erreur: " . $paiement->error, LOG_ERR);
+					$db->rollback();
+				}
+			}
+		}
+		setEventMessage($langs->trans("StripeManualPaymentsAdded", $added), 'mesgs');
+	} catch (Exception $e) {
+		setEventMessage($e->getMessage(), 'errors');
+	}
+}
+
+
+if ($action == 'manual_update_stripe_fees' && $user->admin) {
+
+	require_once DOL_DOCUMENT_ROOT . '/compta/bank/class/account.class.php';
+	require_once DOL_DOCUMENT_ROOT . '/stripe/class/stripe.class.php';
+
+	$langs->load("stripe");
+
+	$stripe = new Stripe($db);
+	$form = new Form($db);
+
+	$fk_account_stripe = 5;
+
+	$date_start = dol_mktime(0, 0, 0, GETPOST('date_startmonth', 'int'), GETPOST('date_startday', 'int'), GETPOST('date_startyear', 'int'));
+	$date_end = dol_mktime(23, 59, 59, GETPOST('date_endmonth', 'int'), GETPOST('date_endday', 'int'), GETPOST('date_endyear', 'int'));
+
+	$added = 0;
+	$error = 0;
+	$logDetails = [];
+
+
+	try {
+		$service = (getDolGlobalString('STRIPE_LIVE') && !GETPOST('forcesandbox')) ? 'StripeLive' : 'StripeTest';
+		$stripeacc = $stripe->getStripeAccount($service);
+
+		$params = array('limit' => 100);
+		$options = $stripeacc ? array('stripe_account' => $stripeacc) : array();
+
+		$txn_all = \Stripe\BalanceTransaction::all($params, $options);
+
+		foreach ($txn_all->data as $txn) {
+			if ($txn->fee > 0) {
+				if (($txn->created >= $date_start) && ($txn->created <= $date_end)) {
+					$res = stripeAddPaymentFeeOnBank(
+						$txn->source,
+						$txn->fee / 100,
+						$fk_account_stripe,
+						$txn->id,
+						$txn->created,
+						$txn->created
+					);
+					if ($res > 0) {
+						$added++;
+						$logDetails[] = [
+							'date' => dol_print_date($txn->created, 'dayhour'),
+							'id' => $txn->id,
+							'amount' => price($txn->fee / 100, 0, '', 1, -1, -1, strtoupper($txn->currency)),
+						];
+					}
+				}
+			}
+		}
+
+		setEventMessage($langs->trans("StripeManualFeesAdded", $added), 'mesgs');
+
+		// Log et popup
+		if (!empty($logDetails)) {
+			foreach ($logDetails as $log) {
+				dol_syslog("Stripe fee added: " . $log['date'] . ' - ' . $log['id'] . ' : ' . $log['amount']);
+			}
+		}
+	} catch (Exception $e) {
+		setEventMessage($e->getMessage(), 'errors');
+	}
+}
+
 if ($action == "setlive") {
 	$liveenable = GETPOSTINT('value');
 	$res = dolibarr_set_const($db, "STRIPE_LIVE", $liveenable, 'yesno', 0, '', $conf->entity);
@@ -189,34 +403,34 @@
 
 llxHeader('', $langs->trans("StripeSetup"));
 
-$linkback = '<a href="'.DOL_URL_ROOT.'/admin/modules.php?restore_lastsearch_values=1">'.$langs->trans("BackToModuleList").'</a>';
-print load_fiche_titre($langs->trans("ModuleSetup").' Stripe', $linkback);
+$linkback = '<a href="' . DOL_URL_ROOT . '/admin/modules.php?restore_lastsearch_values=1">' . $langs->trans("BackToModuleList") . '</a>';
+print load_fiche_titre($langs->trans("ModuleSetup") . ' Stripe', $linkback);
 
 $head = stripeadmin_prepare_head();
 
-print '<form method="POST" action="'.$_SERVER["PHP_SELF"].'">';
-print '<input type="hidden" name="token" value="'.newToken().'">';
+print '<form method="POST" action="' . $_SERVER["PHP_SELF"] . '">';
+print '<input type="hidden" name="token" value="' . newToken() . '">';
 print '<input type="hidden" name="action" value="setvalue">';
 
 print dol_get_fiche_head($head, 'stripeaccount', '', -1);
 
 $stripearrayofwebhookevents = array('account.updated', 'payout.created', 'payout.paid', 'charge.pending', 'charge.refunded', 'charge.succeeded', 'charge.failed', 'payment_intent.succeeded', 'payment_intent.payment_failed', 'payment_method.attached', 'payment_method.updated', 'payment_method.card_automatically_updated', 'payment_method.detached', 'source.chargeable', 'customer.deleted');
 
-print '<span class="opacitymedium">'.$langs->trans("StripeDesc")."</span><br>\n";
+print '<span class="opacitymedium">' . $langs->trans("StripeDesc") . "</span><br>\n";
 
 print '<br>';
 
 print '<div class="div-table-responsive-no-min">';
 print '<table class="noborder centpercent">';
 print '<tr class="liste_titre">';
-print '<td>'.$langs->trans("AccountParameter").'</td>';
-print '<td>'.$langs->trans("Value").'</td>';
+print '<td>' . $langs->trans("AccountParameter") . '</td>';
+print '<td>' . $langs->trans("Value") . '</td>';
 print '<td></td>';
 print "</tr>\n";
 
 print '<tr class="oddeven">';
 print '<td>';
-print $langs->trans("StripeLiveEnabled").'</td><td>';
+print $langs->trans("StripeLiveEnabled") . '</td><td>';
 if ($conf->use_javascript_ajax) {
 	print ajax_constantonoff('STRIPE_LIVE');
 } else {
@@ -227,30 +441,30 @@
 
 if (empty($conf->stripeconnect->enabled)) {
 	print '<tr class="oddeven"><td>';
-	print '<span class="fieldrequired">'.$langs->trans("STRIPE_TEST_PUBLISHABLE_KEY").'</span></td><td>';
-	print '<input class="minwidth300" type="text" name="STRIPE_TEST_PUBLISHABLE_KEY" value="' . getDolGlobalString('STRIPE_TEST_PUBLISHABLE_KEY').'" placeholder="'.$langs->trans("Example").': pk_test_xxxxxxxxxxxxxxxxxxxxxxxx">';
+	print '<span class="fieldrequired">' . $langs->trans("STRIPE_TEST_PUBLISHABLE_KEY") . '</span></td><td>';
+	print '<input class="minwidth300" type="text" name="STRIPE_TEST_PUBLISHABLE_KEY" value="' . getDolGlobalString('STRIPE_TEST_PUBLISHABLE_KEY') . '" placeholder="' . $langs->trans("Example") . ': pk_test_xxxxxxxxxxxxxxxxxxxxxxxx">';
 	print '</td><td></td></tr>';
 
 	print '<tr class="oddeven"><td>';
-	print '<span class="titlefield fieldrequired">'.$langs->trans("STRIPE_TEST_SECRET_KEY").'</span></td><td>';
-	print '<input class="minwidth300" type="text" name="STRIPE_TEST_SECRET_KEY" value="' . getDolGlobalString('STRIPE_TEST_SECRET_KEY').'" placeholder="'.$langs->trans("Example").': sk_test_xxxxxxxxxxxxxxxxxxxxxxxx">';
+	print '<span class="titlefield fieldrequired">' . $langs->trans("STRIPE_TEST_SECRET_KEY") . '</span></td><td>';
+	print '<input class="minwidth300" type="text" name="STRIPE_TEST_SECRET_KEY" value="' . getDolGlobalString('STRIPE_TEST_SECRET_KEY') . '" placeholder="' . $langs->trans("Example") . ': sk_test_xxxxxxxxxxxxxxxxxxxxxxxx">';
 	print '</td><td></td></tr>';
 
 	print '<tr class="oddeven"><td>';
-	print '<span class="titlefield">'.$langs->trans("STRIPE_TEST_WEBHOOK_KEY").'</span></td><td>';
+	print '<span class="titlefield">' . $langs->trans("STRIPE_TEST_WEBHOOK_KEY") . '</span></td><td>';
 	if (getDolGlobalInt('MAIN_FEATURES_LEVEL') >= 2) {
-		print '<input class="minwidth300" type="text" name="STRIPE_TEST_WEBHOOK_ID" value="'.getDolGlobalString('STRIPE_TEST_WEBHOOK_ID').'" placeholder="'.$langs->trans("Example").': we_xxxxxxxxxxxxxxxxxxxxxxxx">';
+		print '<input class="minwidth300" type="text" name="STRIPE_TEST_WEBHOOK_ID" value="' . getDolGlobalString('STRIPE_TEST_WEBHOOK_ID') . '" placeholder="' . $langs->trans("Example") . ': we_xxxxxxxxxxxxxxxxxxxxxxxx">';
 		print '<br>';
 	}
-	print '<input class="minwidth300" type="text" name="STRIPE_TEST_WEBHOOK_KEY" value="'.getDolGlobalString('STRIPE_TEST_WEBHOOK_KEY').'" placeholder="'.$langs->trans("Example").': whsec_xxxxxxxxxxxxxxxxxxxxxxxx">';
-	$out = img_picto('', 'globe').' <span class="opacitymedium">'.$langs->trans("ToOfferALinkForTestWebhook").'</span> ';
+	print '<input class="minwidth300" type="text" name="STRIPE_TEST_WEBHOOK_KEY" value="' . getDolGlobalString('STRIPE_TEST_WEBHOOK_KEY') . '" placeholder="' . $langs->trans("Example") . ': whsec_xxxxxxxxxxxxxxxxxxxxxxxx">';
+	$out = img_picto('', 'globe') . ' <span class="opacitymedium">' . $langs->trans("ToOfferALinkForTestWebhook") . '</span> ';
 	$url = dol_buildpath('/public/stripe/ipn.php', 3);
 	$url .= '?test=1';
 	//global $dolibarr_main_instance_unique_id;
 	//$url .= '&securitykey='.dol_hash('stripeipn-'.$dolibarr_main_instance_unique_id.'-'.$conf->global->STRIPE_TEST_PUBLISHABLE_KEY, 'md5');
-	$out .= '<input type="text" id="onlinetestwebhookurl" class="minwidth500" value="'.$url.'" disabled>';
+	$out .= '<input type="text" id="onlinetestwebhookurl" class="minwidth500" value="' . $url . '" disabled>';
 	$out .= ajax_autoselect("onlinetestwebhookurl");
-	print '<br>'.$out;
+	print '<br>' . $out;
 	print '</td><td>';
 	if (getDolGlobalInt('MAIN_FEATURES_LEVEL') >= 2) {
 		if (getDolGlobalString('STRIPE_TEST_WEBHOOK_KEY') && getDolGlobalString('STRIPE_TEST_SECRET_KEY') && getDolGlobalString('STRIPE_TEST_WEBHOOK_ID')) {
@@ -271,10 +485,10 @@
 					$endpoint->save();
 
 					if ($endpoint->status == 'enabled') {
-						print '<a class="reposition" href="'.$_SERVER['PHP_SELF'].'?action=ipn&webhook='.$endpoint->id.'&status=0">';
+						print '<a class="reposition" href="' . $_SERVER['PHP_SELF'] . '?action=ipn&webhook=' . $endpoint->id . '&status=0">';
 						print img_picto($langs->trans("Activated"), 'switch_on');
 					} else {
-						print '<a class="reposition" href="'.$_SERVER['PHP_SELF'].'?action=ipn&webhook='.$endpoint->id.'&status=1">';
+						print '<a class="reposition" href="' . $_SERVER['PHP_SELF'] . '?action=ipn&webhook=' . $endpoint->id . '&status=1">';
 						print img_picto($langs->trans("Disabled"), 'switch_off');
 					}
 				} catch (Exception $e) {
@@ -287,43 +501,93 @@
 			print img_picto($langs->trans("Inactive"), 'statut5');
 		}
 	}
-	print'</td></tr>';
-} else {
-	print '<tr class="oddeven"><td>'.$langs->trans("StripeConnect").'</td>';
-	print '<td><b>'.$langs->trans("StripeConnect_Mode").'</b><br>';
-	print $langs->trans("STRIPE_APPLICATION_FEE_PLATFORM").' ';
-	print price($conf->global->STRIPE_APPLICATION_FEE_PERCENT);
-	print '% + ';
-	print price($conf->global->STRIPE_APPLICATION_FEE);
-	print ' '.$langs->getCurrencySymbol($conf->currency).' '.$langs->trans("minimum").' '.price($conf->global->STRIPE_APPLICATION_FEE_MINIMAL).' '.$langs->getCurrencySymbol($conf->currency);
-	print '</td><td></td></tr>';
+	print '</td></tr>';
 }
 
+// 	//MODIF JOSE
+// if (empty($conf->stripeconnect->enabled)) {
+// 	foreach ($stripeAccounts as $code => $label) {
+// 		print '<tr class="liste_titre"><td colspan="3">' . $langs->trans("StripeAccountConfig") . ' (TEST) - ' . $label . '</td></tr>';
+
+// 		print '<tr class="oddeven"><td>' . $langs->trans("STRIPE_TEST_PUBLISHABLE_KEY") . '</td>';
+// 		print '<td class="right"><input class="minwidth300" type="text" name="STRIPE_TEST_PUBLISHABLE_KEY_' . strtoupper($code) . '" value="' . dol_escape_htmltag(getDolGlobalString('STRIPE_TEST_PUBLISHABLE_KEY_' . strtoupper($code))) . '"></td><td></td></tr>';
+
+// 		print '<tr class="oddeven"><td>' . $langs->trans("STRIPE_TEST_SECRET_KEY") . '</td>';
+// 		print '<td class="right"><input class="minwidth300" type="text" name="STRIPE_TEST_SECRET_KEY_' . strtoupper($code) . '" value="' . dol_escape_htmltag(getDolGlobalString('STRIPE_TEST_SECRET_KEY_' . strtoupper($code))) . '"></td><td></td></tr>';
+
+// 		print '<tr class="oddeven"><td>' . $langs->trans("STRIPE_TEST_WEBHOOK_KEY") . '</td>';
+// 		print '<td class="right">';
+// 		print '<input class="minwidth300" type="text" name="STRIPE_TEST_WEBHOOK_ID_' . strtoupper($code) . '" value="' . dol_escape_htmltag(getDolGlobalString('STRIPE_TEST_WEBHOOK_ID_' . strtoupper($code))) . '" placeholder="we_..."><br>';
+// 		print '<input class="minwidth300" type="text" name="STRIPE_TEST_WEBHOOK_KEY_' . strtoupper($code) . '" value="' . dol_escape_htmltag(getDolGlobalString('STRIPE_TEST_WEBHOOK_KEY_' . strtoupper($code))) . '" placeholder="whsec_...">';
+
+// 		$url = dol_buildpath('/public/stripe/ipn.php', 3) . '?test=1?account=' . $code;;
+// 		$out = img_picto('', 'globe') . ' <span class="opacitymedium">' . $langs->trans("ToOfferALinkForTestWebhook") . '</span> ';
+// 		$out .= '<input type="text" id="onlinetestwebhookurl_' . $code . '" class="minwidth500" value="' . $url . '" disabled>';
+// 		$out .= ajax_autoselect("onlinetestwebhookurl_" . $code);
+// 		print '<br>' . $out;
+// 		print '</td><td></td></tr>';
+// 	}
+// } else {
+// 	print '<tr class="oddeven"><td>' . $langs->trans("StripeConnect") . '</td>';
+// 	print '<td><b>' . $langs->trans("StripeConnect_Mode") . '</b><br>';
+// 	print $langs->trans("STRIPE_APPLICATION_FEE_PLATFORM") . ' ';
+// 	print price($conf->global->STRIPE_APPLICATION_FEE_PERCENT);
+// 	print '% + ';
+// 	print price($conf->global->STRIPE_APPLICATION_FEE);
+// 	print ' ' . $langs->getCurrencySymbol($conf->currency) . ' ' . $langs->trans("minimum") . ' ' . price($conf->global->STRIPE_APPLICATION_FEE_MINIMAL) . ' ' . $langs->getCurrencySymbol($conf->currency);
+// 	print '</td><td></td></tr>';
+// }
+
+// if (empty($conf->stripeconnect->enabled)) {
+// 	foreach ($stripeAccounts as $code => $label) {
+// 		print '<tr class="liste_titre"><td colspan="3">' . $langs->trans("StripeAccountConfig") . ' (LIVE) - ' . $label . '</td></tr>';
+
+// 		print '<tr class="oddeven"><td>' . $langs->trans("STRIPE_LIVE_PUBLISHABLE_KEY") . '</td>';
+// 		print '<td class="right"><input class="minwidth300" type="text" name="STRIPE_LIVE_PUBLISHABLE_KEY_' . strtoupper($code) . '" value="' . dol_escape_htmltag(getDolGlobalString('STRIPE_LIVE_PUBLISHABLE_KEY_' . strtoupper($code))) . '"></td><td></td></tr>';
+
+// 		print '<tr class="oddeven"><td>' . $langs->trans("STRIPE_LIVE_SECRET_KEY") . '</td>';
+// 		print '<td class="right"><input class="minwidth300" type="text" name="STRIPE_LIVE_SECRET_KEY_' . strtoupper($code) . '" value="' . dol_escape_htmltag(getDolGlobalString('STRIPE_LIVE_SECRET_KEY_' . strtoupper($code))) . '"></td><td></td></tr>';
+
+// 		print '<tr class="oddeven"><td>' . $langs->trans("STRIPE_LIVE_WEBHOOK_KEY") . '</td>';
+// 		print '<td class="right">';
+// 		print '<input class="minwidth300" type="text" name="STRIPE_LIVE_WEBHOOK_ID_' . strtoupper($code) . '" value="' . dol_escape_htmltag(getDolGlobalString('STRIPE_LIVE_WEBHOOK_ID_' . strtoupper($code))) . '" placeholder="we_..."><br>';
+// 		print '<input class="minwidth300" type="text" name="STRIPE_LIVE_WEBHOOK_KEY_' . strtoupper($code) . '" value="' . dol_escape_htmltag(getDolGlobalString('STRIPE_LIVE_WEBHOOK_KEY_' . strtoupper($code))) . '" placeholder="whsec_...">';
+
+// 		$url = dol_buildpath('/public/stripe/ipn.php', 3) . '?account=' . $code;
+// 		$out = img_picto('', 'globe') . ' <span class="opacitymedium">' . $langs->trans("ToOfferALinkForLiveWebhook") . '</span> ';
+// 		$out .= '<input type="text" id="onlinelivewebhookurl_' . $code . '" class="minwidth500" value="' . $url . '" disabled>';
+// 		$out .= ajax_autoselect("onlinelivewebhookurl_" . $code);
+// 		print '<br>' . $out;
+// 		print '</td><td></td></tr>';
+// 	}
+// }
+
+
 if (empty($conf->stripeconnect->enabled)) {
 	print '<tr class="oddeven"><td>';
-	print '<span class="fieldrequired">'.$langs->trans("STRIPE_LIVE_PUBLISHABLE_KEY").'</span></td><td>';
-	print '<input class="minwidth300" type="text" name="STRIPE_LIVE_PUBLISHABLE_KEY" value="'.getDolGlobalString('STRIPE_LIVE_PUBLISHABLE_KEY').'" placeholder="'.$langs->trans("Example").': pk_live_xxxxxxxxxxxxxxxxxxxxxxxx">';
+	print '<span class="fieldrequired">' . $langs->trans("STRIPE_LIVE_PUBLISHABLE_KEY") . '</span></td><td>';
+	print '<input class="minwidth300" type="text" name="STRIPE_LIVE_PUBLISHABLE_KEY" value="' . getDolGlobalString('STRIPE_LIVE_PUBLISHABLE_KEY') . '" placeholder="' . $langs->trans("Example") . ': pk_live_xxxxxxxxxxxxxxxxxxxxxxxx">';
 	print '</td><td></td></tr>';
 
 	print '<tr class="oddeven"><td>';
-	print '<span class="fieldrequired">'.$langs->trans("STRIPE_LIVE_SECRET_KEY").'</span></td><td>';
-	print '<input class="minwidth300" type="text" name="STRIPE_LIVE_SECRET_KEY" value="'.getDolGlobalString('STRIPE_LIVE_SECRET_KEY').'" placeholder="'.$langs->trans("Example").': sk_live_xxxxxxxxxxxxxxxxxxxxxxxx">';
+	print '<span class="fieldrequired">' . $langs->trans("STRIPE_LIVE_SECRET_KEY") . '</span></td><td>';
+	print '<input class="minwidth300" type="text" name="STRIPE_LIVE_SECRET_KEY" value="' . getDolGlobalString('STRIPE_LIVE_SECRET_KEY') . '" placeholder="' . $langs->trans("Example") . ': sk_live_xxxxxxxxxxxxxxxxxxxxxxxx">';
 	print '</td><td></td></tr>';
 
 	print '<tr class="oddeven"><td>';
-	print '<span class="titlefield">'.$langs->trans("STRIPE_LIVE_WEBHOOK_KEY").'</span></td><td>';
+	print '<span class="titlefield">' . $langs->trans("STRIPE_LIVE_WEBHOOK_KEY") . '</span></td><td>';
 	if (getDolGlobalInt('MAIN_FEATURES_LEVEL') >= 2) {
-		print '<input class="minwidth300" type="text" name="STRIPE_LIVE_WEBHOOK_ID" value="'.getDolGlobalString('STRIPE_LIVE_WEBHOOK_ID').'" placeholder="'.$langs->trans("Example").': we_xxxxxxxxxxxxxxxxxxxxxxxx">';
+		print '<input class="minwidth300" type="text" name="STRIPE_LIVE_WEBHOOK_ID" value="' . getDolGlobalString('STRIPE_LIVE_WEBHOOK_ID') . '" placeholder="' . $langs->trans("Example") . ': we_xxxxxxxxxxxxxxxxxxxxxxxx">';
 		print '<br>';
 	}
-	print '<input class="minwidth300" type="text" name="STRIPE_LIVE_WEBHOOK_KEY" value="'.getDolGlobalString('STRIPE_LIVE_WEBHOOK_KEY').'" placeholder="'.$langs->trans("Example").': whsec_xxxxxxxxxxxxxxxxxxxxxxxx">';
-	$out = img_picto('', 'globe', 'class="pictofixedwidth"').' <span class="opacitymedium">'.$langs->trans("ToOfferALinkForLiveWebhook").'</span> ';
+	print '<input class="minwidth300" type="text" name="STRIPE_LIVE_WEBHOOK_KEY" value="' . getDolGlobalString('STRIPE_LIVE_WEBHOOK_KEY') . '" placeholder="' . $langs->trans("Example") . ': whsec_xxxxxxxxxxxxxxxxxxxxxxxx">';
+	$out = img_picto('', 'globe', 'class="pictofixedwidth"') . ' <span class="opacitymedium">' . $langs->trans("ToOfferALinkForLiveWebhook") . '</span> ';
 	$url = dol_buildpath('/public/stripe/ipn.php', 3);
 	//global $dolibarr_main_instance_unique_id;
 	//$url .= '?securitykey='.dol_hash('stripeipn-'.$dolibarr_main_instance_unique_id.'-'.$conf->global->STRIPE_LIVE_PUBLISHABLE_KEY, 'md5');
-	$out .= '<input type="text" id="onlinelivewebhookurl" class="minwidth500" value="'.$url.'" disabled>';
+	$out .= '<input type="text" id="onlinelivewebhookurl" class="minwidth500" value="' . $url . '" disabled>';
 	$out .= ajax_autoselect("onlinelivewebhookurl", '0');
-	print '<br>'.$out;
+	print '<br>' . $out;
 	print '</td><td>';
 	if (getDolGlobalInt('MAIN_FEATURES_LEVEL') >= 2) {
 		if (getDolGlobalString('STRIPE_LIVE_WEBHOOK_KEY') && getDolGlobalString('STRIPE_LIVE_SECRET_KEY') && getDolGlobalString('STRIPE_LIVE_WEBHOOK_ID')) {
@@ -343,10 +607,10 @@
 					// @phan-suppress-next-line PhanDeprecatedFunction
 					$endpoint->save();
 					if ($endpoint->status == 'enabled') {
-						print '<a class="reposition" href="'.$_SERVER['PHP_SELF'].'?action=ipn&webhook='.$endpoint->id.'&status=0">';
+						print '<a class="reposition" href="' . $_SERVER['PHP_SELF'] . '?action=ipn&webhook=' . $endpoint->id . '&status=0">';
 						print img_picto($langs->trans("Activated"), 'switch_on');
 					} else {
-						print '<a class="reposition" href="'.$_SERVER['PHP_SELF'].'?action=ipn&webhook='.$endpoint->id.'&status=1">';
+						print '<a class="reposition" href="' . $_SERVER['PHP_SELF'] . '?action=ipn&webhook=' . $endpoint->id . '&status=1">';
 						print img_picto($langs->trans("Disabled"), 'switch_off');
 					}
 				} catch (Exception $e) {
@@ -369,18 +633,18 @@
 print '<div class="div-table-responsive-no-min">';
 print '<table class="noborder centpercent">';
 print '<tr class="liste_titre">';
-print '<td>'.$langs->trans("UsageParameter").'</td>';
-print '<td>'.$langs->trans("Value").'</td>';
+print '<td>' . $langs->trans("UsageParameter") . '</td>';
+print '<td>' . $langs->trans("Value") . '</td>';
 print "</tr>\n";
 
 print '<tr class="oddeven"><td>';
-print $langs->trans("PublicVendorName").'</td><td>';
-print '<input class="minwidth300" type="text" name="ONLINE_PAYMENT_CREDITOR" value="'.getDolGlobalString('ONLINE_PAYMENT_CREDITOR').'">';
-print ' &nbsp; <span class="opacitymedium">'.$langs->trans("Example").': '.$mysoc->name.'</span>';
+print $langs->trans("PublicVendorName") . '</td><td>';
+print '<input class="minwidth300" type="text" name="ONLINE_PAYMENT_CREDITOR" value="' . getDolGlobalString('ONLINE_PAYMENT_CREDITOR') . '">';
+print ' &nbsp; <span class="opacitymedium">' . $langs->trans("Example") . ': ' . $mysoc->name . '</span>';
 print '</td></tr>';
 
 print '<tr class="oddeven"><td>';
-print $langs->trans("BankAccount").'</td><td>';
+print $langs->trans("BankAccount") . '</td><td>';
 print img_picto('', 'bank_account', 'class="pictofixedwidth"');
 $form->select_comptes(getDolGlobalString('STRIPE_BANK_ACCOUNT_FOR_PAYMENTS'), 'STRIPE_BANK_ACCOUNT_FOR_PAYMENTS', 0, '', 1);
 print '</td></tr>';
@@ -388,7 +652,7 @@
 
 // Param to record automatically payouts (received from IPN payout.paid and payout.created)
 print '<tr class="oddeven"><td>';
-print $langs->trans("StripeAutoRecordPayout").'</td><td>';
+print $langs->trans("StripeAutoRecordPayout") . '</td><td>';
 if ($conf->use_javascript_ajax) {
 	print ajax_constantonoff('STRIPE_AUTO_RECORD_PAYOUT', array(), null, 0, 0, 1);
 } else {
@@ -399,12 +663,12 @@
 
 if (getDolGlobalInt('STRIPE_AUTO_RECORD_PAYOUT')) {
 	print '<tr class="oddeven"><td>';
-	print $langs->trans("StripeUserAccountForActions").'</td><td>';
-	print img_picto('', 'user', 'class="pictofixedwidth"').$form->select_dolusers(getDolGlobalString('STRIPE_USER_ACCOUNT_FOR_ACTIONS'), 'STRIPE_USER_ACCOUNT_FOR_ACTIONS', 0);
+	print $langs->trans("StripeUserAccountForActions") . '</td><td>';
+	print img_picto('', 'user', 'class="pictofixedwidth"') . $form->select_dolusers(getDolGlobalString('STRIPE_USER_ACCOUNT_FOR_ACTIONS'), 'STRIPE_USER_ACCOUNT_FOR_ACTIONS', 0);
 	print '</td></tr>';
 
 	print '<tr class="oddeven"><td>';
-	print $langs->trans("BankAccountForBankTransfer").'</td><td>';
+	print $langs->trans("BankAccountForBankTransfer") . '</td><td>';
 	print img_picto('', 'bank_account', 'class="pictofixedwidth"');
 	$form->select_comptes(getDolGlobalString('STRIPE_BANK_ACCOUNT_FOR_BANKTRANSFERS'), 'STRIPE_BANK_ACCOUNT_FOR_BANKTRANSFERS', 0, '', 1);
 	print '</td></tr>';
@@ -413,7 +677,7 @@
 // Card Present for Stripe Terminal
 if (getDolGlobalInt('MAIN_FEATURES_LEVEL') >= 2) {	// TODO Not used by current code
 	print '<tr class="oddeven"><td>';
-	print $langs->trans("STRIPE_CARD_PRESENT").'</td><td>';
+	print $langs->trans("STRIPE_CARD_PRESENT") . '</td><td>';
 	if ($conf->use_javascript_ajax) {
 		print ajax_constantonoff('STRIPE_CARD_PRESENT');
 	} else {
@@ -426,7 +690,7 @@
 // Locations for Stripe Terminal
 if (getDolGlobalInt('MAIN_FEATURES_LEVEL') >= 2) {	// TODO Not used by current code
 	print '<tr class="oddeven"><td>';
-	print $langs->trans("TERMINAL_LOCATION").'</td><td>';
+	print $langs->trans("TERMINAL_LOCATION") . '</td><td>';
 	$service = 'StripeTest';
 	$servicestatus = 0;
 	if (getDolGlobalString('STRIPE_LIVE') && !GETPOST('forcesandbox', 'alpha')) {
@@ -459,7 +723,7 @@
 			}
 		}
 	} catch (Exception $e) {
-		print $e->getMessage().'<br>';
+		print $e->getMessage() . '<br>';
 	}
 
 	// Define the array $location
@@ -476,7 +740,7 @@
 }
 
 print '<tr class="oddeven"><td>';
-print $langs->trans("STRIPE_SEPA_DIRECT_DEBIT").'</td><td>';
+print $langs->trans("STRIPE_SEPA_DIRECT_DEBIT") . '</td><td>';
 if ($conf->use_javascript_ajax) {
 	print ajax_constantonoff('STRIPE_SEPA_DIRECT_DEBIT');
 } else {
@@ -489,7 +753,7 @@
 // Activate Klarna
 if (getDolGlobalInt('MAIN_FEATURES_LEVEL') >= 2) {	// TODO Not used by current code
 	print '<tr class="oddeven"><td>';
-	print $langs->trans("STRIPE_KLARNA").'</td><td>';
+	print $langs->trans("STRIPE_KLARNA") . '</td><td>';
 	if ($conf->use_javascript_ajax) {
 		print ajax_constantonoff('STRIPE_KLARNA');
 	} else {
